local homeVJR = ...

function registerHouseBuilding(_fbxName, _buildingAssetId, _buildingZone)
-- Apply building asset processor
    homeVJR:registerAssetProcessor("models/" .. _fbxName .. ".fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
    })

-- Register common prefab nodes
    homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/homePart", _HomePrefix .. _buildingAssetId .. "_PREFAB")

    homeVJR:register({
--Déclare que l'objet que l'on crée appartient à la class BUILDING_PART
	DataType = "BUILDING_PART",
--Créé l'objet
	Id = _HomePrefix .. _buildingAssetId .. "_PART",
	Name = _HomePrefix .. _buildingAssetId .. "_NAME",
	Description = _HomePrefix .. _buildingAssetId .. "_DESC",
	Category = "CORE",
	BuildingZone = _buildingZone,
--on déclare d'aller chercher _HomePrefix .. _buildingAssetId .. "_PREFAB" pour construire l'object final ( c'est dans le Fbx )
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _HomePrefix .. _buildingAssetId .. "_PREFAB"
	},
--Les ressources nécessaires.
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 0 }
		}
	}
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/homePart", {
	DataType = "COMP_GROUNDED"
    })
    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/homePart/step_0/porte", {
	DataType = "COMP_GROUNDED"
    })

-- The fireplace...
    homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/homePart/step_2/cheminee/SmokeEmitter", _HomePrefix .. _buildingAssetId .. "_SMOKE_EMITTER_PREFAB")

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/homePart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { _HomePrefix .. _buildingAssetId .. "_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/homePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = true
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/homePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
    })
end

registerHouseBuilding("Home2", "_HOME2",
                      { ZoneEntryList = {
                          { Polygon = polygon.createRectangle( {3, 7} ),
                            Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
                        }
                      })
registerHouseBuilding("Home3", "_HOME3",
                      { ZoneEntryList = {
                          { Polygon = polygon.createRectangle( {8, 8} ),
                            Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
                        }
                      })
registerHouseBuilding("Home4", "_HOME4",
                      { ZoneEntryList = {
                          { Polygon = polygon.createRectangle( {4, 8} ),
                            Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
                        }
                      })
registerHouseBuilding("Home5", "_HOME5",
                      { ZoneEntryList = {
                          { Polygon = polygon.createRectangle( {4, 6} ),
                            Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
                        }
                      })
registerHouseBuilding("Home6", "_HOME6",
                      { ZoneEntryList = {
                          { Polygon = polygon.createRectangle( {4, 7} ),
                            Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
                        }
                      })

--------------------------------------------------------------------------
function registerBuildingAssemblage(_fbxName, _buildingAssetId, _buildingZone)
-- Apply building asset processor
    homeVJR:registerAssetProcessor("models/" .. _fbxName .. ".fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
    })
 
-- Register prefab nodes
    homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart", _HomePrefix .. _buildingAssetId .. "_PREFAB")

-- Register the assemblage part
    homeVJR:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. _buildingAssetId .. "_PART",
	Name = _HomePrefix .. _buildingAssetId .. "_NAME",
	Description = _HomePrefix .. _buildingAssetId .. "_DESC",
	Category = "CORE",
	BuildingZone = _buildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { _HomePrefix .. _buildingAssetId .. "_PREFAB" },
                MandatoryBuildingPartList = {
                    { BuildingPart = _HomePrefix .. "_WOODEN_DOOR_PART" }
                    ,{ BuildingPart = _HomePrefix .. "_FENETRE_PART", Probability = 0.5 }
                    ,{ BuildingPart = _HomePrefix .. "_FENETRE_PART", Probability = 0.5 }
                    ,{ BuildingPart = _HomePrefix .. "_FENETRE_PART", Probability = 0.5 }
                    ,{ BuildingPart = _HomePrefix .. "_FENETRE_PART", Probability = 0.5 }
                    ,{ BuildingPart = _HomePrefix .. "_FENETRE_PART", Probability = 0.5 }
               }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 0 }
		}
	}
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart", {
	DataType = "COMP_GROUNDED"
    })

-- several models of door
    homeVJR:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_WOODEN_DOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
                                _HomePrefix .. "_DOOR1_PART"
                                , _HomePrefix .. "_DOOR2_PART"
                                , _HomePrefix .. "_DOOR3_PART"
                          }
        }
    })

    -- Register the door parts
    function registerPortePart(_doorName, _doorAssetId, _doorZone)
        homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/" .. _doorName .. "Part", _HomePrefix .. _doorAssetId .. "_PREFAB")

        homeVJR:register({
        	DataType = "BUILDING_PART",
	        Id = _HomePrefix .. _doorAssetId .. "_PART",
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		    CoreObjectPrefab = _HomePrefix .. _doorAssetId .. "_PREFAB"
	        }
        })

        homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/" .. _doorName .. "Part", {
	    DataType = "COMP_BUILDING_PART",
            BuildingPartType = "MAJOR"
        })

        homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/" .. _doorName .. "Part", {
	    DataType = "COMP_GROUNDED"
        })
    end

    registerPortePart("door1", "_DOOR1", { 0.1, 1 })
    registerPortePart("door2", "_DOOR2", { 0.1, 1 })
    registerPortePart("door3", "_DOOR3", { 1, 1 })

-- Register the fenetre part
    homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/fenetrePart", _HomePrefix .. "_FENETRE_PREFAB")

    homeVJR:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_FENETRE_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _HomePrefix .. "_FENETRE_PREFAB"
	}
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/fenetrePart", {
	DataType = "COMP_BUILDING_PART",
        BuildingPartType = "MAJOR",
    })

-- The fireplace...
    homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart/step_2/cheminee/SmokeEmitter", _HomePrefix .. _buildingAssetId .. "_SMOKE_EMITTER_PREFAB")

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { _HomePrefix .. _buildingAssetId .. "_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = true
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
    })
end

registerBuildingAssemblage("Home11", "_HOME11",
                      { ZoneEntryList = {
                          { Polygon = polygon.createRectangle( {4, 8} ),
                            Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
                        }
                      })


